/*
Copyright The KubeEdge Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/kubeedge/sedna/pkg/apis/sedna/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeFederatedLearningJobs implements FederatedLearningJobInterface
type FakeFederatedLearningJobs struct {
	Fake *FakeSednaV1alpha1
	ns   string
}

var federatedlearningjobsResource = schema.GroupVersionResource{Group: "sedna.io", Version: "v1alpha1", Resource: "federatedlearningjobs"}

var federatedlearningjobsKind = schema.GroupVersionKind{Group: "sedna.io", Version: "v1alpha1", Kind: "FederatedLearningJob"}

// Get takes name of the federatedLearningJob, and returns the corresponding federatedLearningJob object, and an error if there is any.
func (c *FakeFederatedLearningJobs) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.FederatedLearningJob, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(federatedlearningjobsResource, c.ns, name), &v1alpha1.FederatedLearningJob{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.FederatedLearningJob), err
}

// List takes label and field selectors, and returns the list of FederatedLearningJobs that match those selectors.
func (c *FakeFederatedLearningJobs) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.FederatedLearningJobList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(federatedlearningjobsResource, federatedlearningjobsKind, c.ns, opts), &v1alpha1.FederatedLearningJobList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.FederatedLearningJobList{ListMeta: obj.(*v1alpha1.FederatedLearningJobList).ListMeta}
	for _, item := range obj.(*v1alpha1.FederatedLearningJobList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested federatedLearningJobs.
func (c *FakeFederatedLearningJobs) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(federatedlearningjobsResource, c.ns, opts))

}

// Create takes the representation of a federatedLearningJob and creates it.  Returns the server's representation of the federatedLearningJob, and an error, if there is any.
func (c *FakeFederatedLearningJobs) Create(ctx context.Context, federatedLearningJob *v1alpha1.FederatedLearningJob, opts v1.CreateOptions) (result *v1alpha1.FederatedLearningJob, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(federatedlearningjobsResource, c.ns, federatedLearningJob), &v1alpha1.FederatedLearningJob{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.FederatedLearningJob), err
}

// Update takes the representation of a federatedLearningJob and updates it. Returns the server's representation of the federatedLearningJob, and an error, if there is any.
func (c *FakeFederatedLearningJobs) Update(ctx context.Context, federatedLearningJob *v1alpha1.FederatedLearningJob, opts v1.UpdateOptions) (result *v1alpha1.FederatedLearningJob, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(federatedlearningjobsResource, c.ns, federatedLearningJob), &v1alpha1.FederatedLearningJob{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.FederatedLearningJob), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeFederatedLearningJobs) UpdateStatus(ctx context.Context, federatedLearningJob *v1alpha1.FederatedLearningJob, opts v1.UpdateOptions) (*v1alpha1.FederatedLearningJob, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(federatedlearningjobsResource, "status", c.ns, federatedLearningJob), &v1alpha1.FederatedLearningJob{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.FederatedLearningJob), err
}

// Delete takes name of the federatedLearningJob and deletes it. Returns an error if one occurs.
func (c *FakeFederatedLearningJobs) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(federatedlearningjobsResource, c.ns, name), &v1alpha1.FederatedLearningJob{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeFederatedLearningJobs) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(federatedlearningjobsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.FederatedLearningJobList{})
	return err
}

// Patch applies the patch and returns the patched federatedLearningJob.
func (c *FakeFederatedLearningJobs) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.FederatedLearningJob, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(federatedlearningjobsResource, c.ns, name, pt, data, subresources...), &v1alpha1.FederatedLearningJob{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.FederatedLearningJob), err
}
