/*
Copyright The KubeEdge Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/kubeedge/sedna/pkg/apis/sedna/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeLifelongLearningJobs implements LifelongLearningJobInterface
type FakeLifelongLearningJobs struct {
	Fake *FakeSednaV1alpha1
	ns   string
}

var lifelonglearningjobsResource = schema.GroupVersionResource{Group: "sedna.io", Version: "v1alpha1", Resource: "lifelonglearningjobs"}

var lifelonglearningjobsKind = schema.GroupVersionKind{Group: "sedna.io", Version: "v1alpha1", Kind: "LifelongLearningJob"}

// Get takes name of the lifelongLearningJob, and returns the corresponding lifelongLearningJob object, and an error if there is any.
func (c *FakeLifelongLearningJobs) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.LifelongLearningJob, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(lifelonglearningjobsResource, c.ns, name), &v1alpha1.LifelongLearningJob{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LifelongLearningJob), err
}

// List takes label and field selectors, and returns the list of LifelongLearningJobs that match those selectors.
func (c *FakeLifelongLearningJobs) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.LifelongLearningJobList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(lifelonglearningjobsResource, lifelonglearningjobsKind, c.ns, opts), &v1alpha1.LifelongLearningJobList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.LifelongLearningJobList{ListMeta: obj.(*v1alpha1.LifelongLearningJobList).ListMeta}
	for _, item := range obj.(*v1alpha1.LifelongLearningJobList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested lifelongLearningJobs.
func (c *FakeLifelongLearningJobs) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(lifelonglearningjobsResource, c.ns, opts))

}

// Create takes the representation of a lifelongLearningJob and creates it.  Returns the server's representation of the lifelongLearningJob, and an error, if there is any.
func (c *FakeLifelongLearningJobs) Create(ctx context.Context, lifelongLearningJob *v1alpha1.LifelongLearningJob, opts v1.CreateOptions) (result *v1alpha1.LifelongLearningJob, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(lifelonglearningjobsResource, c.ns, lifelongLearningJob), &v1alpha1.LifelongLearningJob{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LifelongLearningJob), err
}

// Update takes the representation of a lifelongLearningJob and updates it. Returns the server's representation of the lifelongLearningJob, and an error, if there is any.
func (c *FakeLifelongLearningJobs) Update(ctx context.Context, lifelongLearningJob *v1alpha1.LifelongLearningJob, opts v1.UpdateOptions) (result *v1alpha1.LifelongLearningJob, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(lifelonglearningjobsResource, c.ns, lifelongLearningJob), &v1alpha1.LifelongLearningJob{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LifelongLearningJob), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeLifelongLearningJobs) UpdateStatus(ctx context.Context, lifelongLearningJob *v1alpha1.LifelongLearningJob, opts v1.UpdateOptions) (*v1alpha1.LifelongLearningJob, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(lifelonglearningjobsResource, "status", c.ns, lifelongLearningJob), &v1alpha1.LifelongLearningJob{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LifelongLearningJob), err
}

// Delete takes name of the lifelongLearningJob and deletes it. Returns an error if one occurs.
func (c *FakeLifelongLearningJobs) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(lifelonglearningjobsResource, c.ns, name), &v1alpha1.LifelongLearningJob{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeLifelongLearningJobs) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(lifelonglearningjobsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.LifelongLearningJobList{})
	return err
}

// Patch applies the patch and returns the patched lifelongLearningJob.
func (c *FakeLifelongLearningJobs) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.LifelongLearningJob, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(lifelonglearningjobsResource, c.ns, name, pt, data, subresources...), &v1alpha1.LifelongLearningJob{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.LifelongLearningJob), err
}
